<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Put_Project_Worker_Role_RequestType StructType
 * Meta information extracted from the WSDL
 * - documentation: Element containing Project Worker Role reference for update and all Project Worker Role data
 * @subpackage Structs
 */
class Put_Project_Worker_Role_RequestType extends AbstractStructBase
{
    /**
     * The Project_Worker_Role_Reference
     * Meta information extracted from the WSDL
     * - documentation: Project Worker Role Reference
     * - minOccurs: 0
     * @var \StructType\Project_RoleObjectType
     */
    public $Project_Worker_Role_Reference;
    /**
     * The Project_Worker_Role_Data
     * Meta information extracted from the WSDL
     * - documentation: Project Worker Role Data
     * @var \StructType\Project_Worker_Role_DataType
     */
    public $Project_Worker_Role_Data;
    /**
     * The Add_Only
     * Meta information extracted from the WSDL
     * - documentation: Add Only
     * @var bool
     */
    public $Add_Only;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Put_Project_Worker_Role_RequestType
     * @uses Put_Project_Worker_Role_RequestType::setProject_Worker_Role_Reference()
     * @uses Put_Project_Worker_Role_RequestType::setProject_Worker_Role_Data()
     * @uses Put_Project_Worker_Role_RequestType::setAdd_Only()
     * @uses Put_Project_Worker_Role_RequestType::setVersion()
     * @param \StructType\Project_RoleObjectType $project_Worker_Role_Reference
     * @param \StructType\Project_Worker_Role_DataType $project_Worker_Role_Data
     * @param bool $add_Only
     * @param string $version
     */
    public function __construct(\StructType\Project_RoleObjectType $project_Worker_Role_Reference = null, \StructType\Project_Worker_Role_DataType $project_Worker_Role_Data = null, $add_Only = null, $version = null)
    {
        $this
            ->setProject_Worker_Role_Reference($project_Worker_Role_Reference)
            ->setProject_Worker_Role_Data($project_Worker_Role_Data)
            ->setAdd_Only($add_Only)
            ->setVersion($version);
    }
    /**
     * Get Project_Worker_Role_Reference value
     * @return \StructType\Project_RoleObjectType|null
     */
    public function getProject_Worker_Role_Reference()
    {
        return $this->Project_Worker_Role_Reference;
    }
    /**
     * Set Project_Worker_Role_Reference value
     * @param \StructType\Project_RoleObjectType $project_Worker_Role_Reference
     * @return \StructType\Put_Project_Worker_Role_RequestType
     */
    public function setProject_Worker_Role_Reference(\StructType\Project_RoleObjectType $project_Worker_Role_Reference = null)
    {
        $this->Project_Worker_Role_Reference = $project_Worker_Role_Reference;
        return $this;
    }
    /**
     * Get Project_Worker_Role_Data value
     * @return \StructType\Project_Worker_Role_DataType|null
     */
    public function getProject_Worker_Role_Data()
    {
        return $this->Project_Worker_Role_Data;
    }
    /**
     * Set Project_Worker_Role_Data value
     * @param \StructType\Project_Worker_Role_DataType $project_Worker_Role_Data
     * @return \StructType\Put_Project_Worker_Role_RequestType
     */
    public function setProject_Worker_Role_Data(\StructType\Project_Worker_Role_DataType $project_Worker_Role_Data = null)
    {
        $this->Project_Worker_Role_Data = $project_Worker_Role_Data;
        return $this;
    }
    /**
     * Get Add_Only value
     * @return bool|null
     */
    public function getAdd_Only()
    {
        return $this->Add_Only;
    }
    /**
     * Set Add_Only value
     * @param bool $add_Only
     * @return \StructType\Put_Project_Worker_Role_RequestType
     */
    public function setAdd_Only($add_Only = null)
    {
        // validation for constraint: boolean
        if (!is_null($add_Only) && !is_bool($add_Only)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($add_Only, true), gettype($add_Only)), __LINE__);
        }
        $this->Add_Only = $add_Only;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Put_Project_Worker_Role_RequestType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
